'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Container
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * React Component using RenderProps pattern to
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * empower react developers to exclude the
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * confusing `this` keyword and the need to call setState
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Basically React Developers could use functional components
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * in their whole application, and not have to worry about
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * `class`, `setState` or the confusing `this` keywords
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Usage:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *   import Container from 'react-container'
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *   const MyComponent = props => {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *     return (
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *       <Container initial={{title: 'Hello World'}}>
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *         {props => <h1>{props.title}</h1>}
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *       </Container>
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *     )
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *   }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *   so far you have three optional properties that you can set
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *   - intial = which sets the initial state and passes it as props
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *   - mount = which gives you a dispatch function do manage on mount
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *   - actions = which works the same as mapDispatchToProps
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var Container = function (_React$Component) {
  _inherits(Container, _React$Component);

  function Container(props) {
    _classCallCheck(this, Container);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _this.state = props.initialState || {};
    return _this;
  }

  Container.prototype.componentDidMount = function componentDidMount() {
    if (this.props.didMount) {
      this.props.didMount(this.dispatch.bind(this));
    }
  };

  Container.prototype.dispatch = function dispatch(_ref) {
    var _setState;

    var type = _ref.type,
        payload = _ref.payload;

    if (!type) {
      throw new Error('action.type must be defined!');
    }
    if (payload === undefined) {
      throw new Error('action.payload must be defined!');
    }
    if (typeof type !== 'string') {
      throw new Error('action.type must be a string!');
    }
    this.setState((_setState = {}, _setState[type] = payload, _setState));
  };

  Container.prototype.render = function render() {
    var noop = function noop() {
      return null;
    };
    var Component = this.props.children || this.props.render || noop;

    var actions = Object.assign({ dispatch: this.dispatch.bind(this) }, typeof this.props.actions === 'function' ? this.props.actions(this.dispatch.bind(this), this.state) : {});

    return _react2.default.createElement(Component, _extends({}, this.state, actions));
  };

  return Container;
}(_react2.default.Component);

Container.propTypes = process.env.NODE_ENV !== "production" ? {
  initialState: _propTypes2.default.object,
  didMount: _propTypes2.default.func,
  actions: _propTypes2.default.func,
  children: _propTypes2.default.func
} : {};

exports.default = Container;
module.exports = exports['default'];